<template lang="pug">
  corpus-edit(:value="parsedCorpus" :key="key")
</template>

<script>
/* eslint-disable */
import exactCorpusGql from '~/apollo/queries/exactCorpus'
import { parseCorpus } from '~/apollo/queryBuilderCorpus'

import CorpusEdit from '~/components/CorpusEdit'

export default {
  components: {
    CorpusEdit
  },
  data() {
    return {
      corpus: {},
      key: '',
      notmine: false
    }
  },
  watch: {
    '$route.params.id': async function(to, from) {
      try {
        const res = await this.$apolloProvider.defaultClient
          .query({
            query: exactCorpusGql,
            variables: { pk: this.$route.params.id },
            fetchPolicy: 'cache-and-network'
          })
          .then(({ data }) => data.corpus)
        this.corpus = res
        this.key = to
      } catch (e) {
        this.$router.go(-1)
      }
    }
  },
  computed: {
    parsedCorpus() {
      return parseCorpus(this.corpus)
    }
  },
  async asyncData({ params, store, app, route }) {
    const res = await app.apolloProvider.defaultClient
      .query({
        query: exactCorpusGql,
        variables: { pk: params.id },
        fetchPolicy: 'network-only'
      })
      .then(({ data }) => {
        return { corpus: data.corpus }
      })
    // verify if current user is among owners, else redirect
    if (!res.corpus.actor.username === store.getters['user/getActorOrId'] && !store.getters['user/isAdministrator']) {
      return { notmine: true }
    }
    // if all is good:
    // - open corpus in nav
    // - assign corpus data
    store.commit('corpora/addOpenCorpora', {
      title: res.corpus.title,
      pk: params.id
    })
    return res
  },
  mounted() {
    if (this.notmine) this.$router.go(-1)
  }
}
</script>
